import GppCompiler from "../Compiler/GppCompiler";
import printDebug from "../Tools/DebugPrint";
import { getDefaultCompiler, setDefaultCompiler } from "../Tools/DefaultCompiler";
import setGetDefaultCompiler from "../Tools/setGetDefaultCompiler";
import HaveCompiler from "./interface/HaveCompiler";
import Optimize from "./interface/Optimize";
import SourceFiles from "./interface/SourceFiles";
import Project from "./Project";

export default class CppProject implements Project , SourceFiles,HaveCompiler,Optimize {
    name: string;
    compiler: GppCompiler;
    sourceFiles: string[]=[];
    optimize: "fast" | "fastest" | "normal" = "fast"
    typeName: string = "cpp";

    constructor(name:string)
    constructor(name:string,compiler:GppCompiler)

    constructor(name:string,compiler?:GppCompiler){
        printDebug(`adding new ${this.typeName} project`)
        if(compiler){
            this.compiler = compiler
        }else{
            this.compiler = setGetDefaultCompiler("g++",()=>{return new GppCompiler()})
        }
        this.name=name
    }
}